#ifndef __GL_WINDOW_H__
#define __GL_WINDOW_H__

#include "ui/FL/Fl.H"
#include "ui/FL/Fl_Gl_Window.H"

#include <GL/glut.h>

#include <stdio.h>
#include <ctype.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

class gl_window : public Fl_Gl_Window
{
	private:

		float near_clip, far_clip;
		float asp_ratio;

		float rotx, roty, rotz;

		unsigned char * _texture[5];
		unsigned int tex_height[5], tex_width[5];

		void loadPPM(const char *, int);
		void loadTex(int);

		// texture mapped polys
		void drawSphere(GLdouble, GLint, GLint);
		void drawBox(double);

	public:
		
		gl_window(int, int, int, int, const char*);
		~gl_window(void);

		void rotate(void);

		void draw(void);
		int handle(int);

};

#endif
