#ifndef __GL_WINDOW_H__
#define __GL_WINDOW_H__

#include "ui/FL/Fl.H"
#include "ui/FL/Fl_Gl_Window.H"

#include <GL/glut.h>

#include <stdio.h>
#include <ctype.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

class gl_window : public Fl_Gl_Window
{
	private:

		float near_clip, far_clip;
		float asp_ratio;

		float rotx, roty, rotz;
		float cam_x, cam_y, cam_z;
		float eye_x, eye_y, eye_z;

		float fog_density;
		float fog_r, fog_g, fog_b;

		unsigned char * _texture[5];
		unsigned int tex_height[5], tex_width[5];

		void loadPPM(const char *, int);
		void loadTex(int);

		// texture mapped polys
		void drawSphere(GLdouble, GLint, GLint);
		void drawBox(double);

	public:
		
		gl_window(int, int, int, int, const char*);
		~gl_window(void);

		void rotate(void);
		inline void setFogDensity(float _d) { fog_density = _d; }
		inline void setFogRGB(float _r, float _g, float _b)
			 { fog_r = _r; fog_g = _g; fog_b = _b; }

		void draw(void);
		int handle(int);

};

#endif
