#include "gl_window.h"
#include <stdio.h>

#include "ui/FL/Fl_Slider.H"

void idle_cb(void *);

// window
// this now needs to be global, because the idle callback has no
// way to be passed in a pointer to the window :(

// create our main window
Fl_Window * parent = new Fl_Window(0, 0, 500, 500, "Canvas");
gl_window * window = new gl_window(0, 0, 500, 400, "Canvas");

//slider bars
Fl_Slider * fog_slider = new Fl_Slider(20, 420, 100, 15, "Fog Density");
Fl_Slider * fog_r_slider = new Fl_Slider(200, 410, 100, 15, "Red");
Fl_Slider * fog_g_slider = new Fl_Slider(200, 440, 100, 15, "Green");
Fl_Slider * fog_b_slider = new Fl_Slider(200, 470, 100, 15, "Blue");

void fog_cb(Fl_Widget *, void *);
void fog_rgb_cb(Fl_Widget *, void *);

int main(int argc, char* argv[])
{
	// set up slider
	fog_slider->type(1);
	fog_slider->value(.5);
	fog_slider->minimum(0);
	fog_slider->maximum(1);
	fog_slider->step(0.01);
	fog_r_slider->type(1);
	fog_g_slider->type(1);
	fog_b_slider->type(1);
	fog_r_slider->minimum(0);
	fog_r_slider->maximum(1);
	fog_r_slider->step(0.01);
	fog_g_slider->minimum(0);
	fog_g_slider->maximum(1);
	fog_g_slider->step(0.01);
	fog_b_slider->minimum(0);
	fog_b_slider->maximum(1);
	fog_b_slider->step(0.01);
	fog_slider->callback(fog_cb);
	fog_r_slider->callback(fog_rgb_cb);
	fog_g_slider->callback(fog_rgb_cb);
	fog_b_slider->callback(fog_rgb_cb);
		
	// close it up, show it
	glutCreateWindow("");
	parent->add(window);
	parent->end();
	window->end();
	parent->show();
	window->show();

	// idle callback
	Fl:: add_timeout(0.01, idle_cb);

	// event loop
	return Fl :: run();
}

void idle_cb(void *)
{
	// recall timeout
	Fl::repeat_timeout(0.01, idle_cb);

	if(window->visible())
		window->rotate();
}

void fog_cb(Fl_Widget *, void *)
{
	window->setFogDensity(fog_slider->value()/10.0);
}

void fog_rgb_cb(Fl_Widget *, void *)
{
	window->setFogRGB(fog_r_slider->value(), fog_g_slider->value(),
					  fog_b_slider->value());
}
